<?php
namespace Mirasvit\Sorting\Model\Indexer;

/**
 * Interceptor class for @see \Mirasvit\Sorting\Model\Indexer
 */
class Interceptor extends \Mirasvit\Sorting\Model\Indexer implements \Magento\Framework\Interception\InterceptorInterface
{
    use \Magento\Framework\Interception\Interceptor;

    public function __construct(\Magento\Framework\App\ResourceConnection $resource, \Magento\Framework\Event\ManagerInterface $eventManager, \Mirasvit\Sorting\Repository\RankingFactorRepository $rankingFactorRepository)
    {
        $this->___init();
        parent::__construct($resource, $eventManager, $rankingFactorRepository);
    }

    /**
     * {@inheritdoc}
     */
    public function execute($ids)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'execute');
        return $pluginInfo ? $this->___callPlugins('execute', func_get_args(), $pluginInfo) : parent::execute($ids);
    }

    /**
     * {@inheritdoc}
     */
    public function executeFull()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'executeFull');
        return $pluginInfo ? $this->___callPlugins('executeFull', func_get_args(), $pluginInfo) : parent::executeFull();
    }

    /**
     * {@inheritdoc}
     */
    public function executeRankingFactor(array $rankingFactorIds = [], array $productIds = [])
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'executeRankingFactor');
        return $pluginInfo ? $this->___callPlugins('executeRankingFactor', func_get_args(), $pluginInfo) : parent::executeRankingFactor($rankingFactorIds, $productIds);
    }

    /**
     * {@inheritdoc}
     */
    public function executeList(array $ids)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'executeList');
        return $pluginInfo ? $this->___callPlugins('executeList', func_get_args(), $pluginInfo) : parent::executeList($ids);
    }

    /**
     * {@inheritdoc}
     */
    public function executeRow($id)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'executeRow');
        return $pluginInfo ? $this->___callPlugins('executeRow', func_get_args(), $pluginInfo) : parent::executeRow($id);
    }

    /**
     * {@inheritdoc}
     */
    public function getIdentities()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'getIdentities');
        return $pluginInfo ? $this->___callPlugins('getIdentities', func_get_args(), $pluginInfo) : parent::getIdentities();
    }
}
